
package de.ivu.elect.business.person.boundary;

import javax.enterprise.context.RequestScoped;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;

import de.ivu.elect.business.person.entity.Beruf;

@RequestScoped
@Named(BerufConversationSelect.COMPONENT_NAME)
public class BerufConversationSelect implements java.io.Serializable {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "berufConversationSelect";

  @Inject
  protected transient BerufExtendedDAO entityDAO;

  @Inject
  @ConversationGroup(BerufConversationStore.class)
  protected transient BerufConversationStore conversationStore;

  public BerufConversationSelect() {
    super();
  }

  public boolean isSelected() {
    return getEntityPK() != null;
  }

  public Beruf getEntity() {
    return getEntityInternal();
  }

  private Beruf getEntityInternal() {
    if (getEntityPK() == null) {
      return null;
    }

    return attach(getEntityPK());
  }

  public void setEntity(Beruf entity) {
    setEntityAttached(attach(entity));
  }

  public void setEntity( de.ivu.elect.business.person.entity.BerufPK  pk) {
    setEntityAttached(attach(pk));
  }

  protected void setEntityAttached(Beruf entity) {
    if(entity == null) {
      setEntityPK(null);
    } else {
      setEntityPK(entity.getPk());
    }
  }

  public
    de.ivu.elect.business.person.entity.BerufPK
   getEntityPK() {
    return conversationStore.getEntityPK();
  }

  public void setEntityPK(
    de.ivu.elect.business.person.entity.BerufPK
   entityPK) {
    conversationStore.setEntityPK(entityPK);
  }

  protected Beruf attach(Beruf entity) {
    if (entity == null){
      return null;
    }

    return attach(entity.getPk());
  }

  protected Beruf attach( de.ivu.elect.business.person.entity.BerufPK  pk) {
    if (pk == null) {
      return null;
    }

    return entityDAO.findByPrimaryKey(pk);
  }

  public void clearEntity() {
    setEntityPK(null);

    conversationStore.close();
  }
}
